require"luci.ip"
require"nixio.fs"
require"luci.sys"
local a,t,e
a=Map("shadowsocksr")
t=a:section(TypedSection,"access_control")
t.anonymous=true
t:tab("Interface",translate("Interface control"))
e=t:taboption("Interface",DynamicList,"Interface",translate("Interface"))
e.template="cbi/network_netlist"
e.widget="checkbox"
e.nocreate=true
e.unspecified=true
e.description=translate("Listen only on the given interface or, if unspecified, on all")
t:tab("wan_ac",translate("WAN IP AC"))
e=t:taboption("wan_ac",DynamicList,"wan_bp_ips",translate("WAN White List IP"))
e.datatype="ip4addr"
e=t:taboption("wan_ac",DynamicList,"wan_fw_ips",translate("WAN Force Proxy IP"))
e.datatype="ip4addr"
t:tab("lan_ac",translate("LAN IP AC"))
e=t:taboption("lan_ac",ListValue,"lan_ac_mode",translate("LAN Access Control"))
e:value("0",translate("Disable"))
e:value("w",translate("Allow listed only"))
e:value("b",translate("Allow all except listed"))
e.rmempty=false
e=t:taboption("lan_ac",DynamicList,"lan_ac_ips",translate("LAN Host List"))
e.datatype="ipaddr"
luci.ip.neighbors({family=4},function(t)
if t.reachable then
e:value(t.dest:string())
end
end)
e:depends("lan_ac_mode","w")
e:depends("lan_ac_mode","b")
e=t:taboption("lan_ac",DynamicList,"lan_bp_ips",translate("LAN Bypassed Host List"))
e.datatype="ipaddr"
luci.ip.neighbors({family=4},function(t)
if t.reachable then
e:value(t.dest:string())
end
end)
e=t:taboption("lan_ac",DynamicList,"lan_fp_ips",translate("LAN Force Proxy Host List"))
e.datatype="ipaddr"
luci.ip.neighbors({family=4},function(t)
if t.reachable then
e:value(t.dest:string())
end
end)
e=t:taboption("lan_ac",DynamicList,"lan_gm_ips",translate("Game Mode Host List"))
e.datatype="ipaddr"
luci.ip.neighbors({family=4},function(t)
if t.reachable then
e:value(t.dest:string())
end
end)
t:tab("esc",translate("Bypass Domain List"))
local o="/etc/ssrplus/white.list"
e=t:taboption("esc",TextValue,"escconf")
e.rows=13
e.wrap="off"
e.rmempty=true
e.cfgvalue=function(t,t)
return nixio.fs.readfile(o)or""
end
e.write=function(a,a,t)
nixio.fs.writefile(o,t:gsub("\r\n","\n"))
end
e.remove=function(e,e,e)
nixio.fs.writefile(o,"")
end
t:tab("block",translate("Black Domain List"))
local o="/etc/ssrplus/black.list"
e=t:taboption("block",TextValue,"blockconf")
e.rows=13
e.wrap="off"
e.rmempty=true
e.cfgvalue=function(t,t)
return nixio.fs.readfile(o)or" "
end
e.write=function(a,a,t)
nixio.fs.writefile(o,t:gsub("\r\n","\n"))
end
e.remove=function(e,e,e)
nixio.fs.writefile(o,"")
end
t:tab("denydomain",translate("Deny Domain List"))
local o="/etc/ssrplus/deny.list"
e=t:taboption("denydomain",TextValue,"denydomainconf")
e.rows=13
e.wrap="off"
e.rmempty=true
e.cfgvalue=function(t,t)
return nixio.fs.readfile(o)or" "
end
e.write=function(a,a,t)
nixio.fs.writefile(o,t:gsub("\r\n","\n"))
end
e.remove=function(e,e,e)
nixio.fs.writefile(o,"")
end
t:tab("netflix",translate("Netflix Domain List"))
local o="/etc/ssrplus/netflix.list"
e=t:taboption("netflix",TextValue,"netflixconf")
e.rows=13
e.wrap="off"
e.rmempty=true
e.cfgvalue=function(t,t)
return nixio.fs.readfile(o)or" "
end
e.write=function(a,a,t)
nixio.fs.writefile(o,t:gsub("\r\n","\n"))
end
e.remove=function(e,e,e)
nixio.fs.writefile(o,"")
end
if luci.sys.call('[ -f "/www/luci-static/resources/uci.js" ]')==0 then
a.apply_on_parse=true
function a.on_apply(e)
luci.sys.call("/etc/init.d/shadowsocksr reload > /dev/null 2>&1 &")
end
end
return a
